/***************************************************************************
 $RCSfile: auth.cpp,v $
                             -------------------
    cvs         : $Id: auth.cpp,v 1.3 2002/10/26 23:41:03 cstim Exp $
    begin       : Thu Jan 24 2002
    copyright   : (C) 2002 by Martin Preuss
    email       : openhbci@aquamaniac.de

 ***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or         *
 *   modify it under the terms of the GNU Lesser General Public            *
 *   License as published by the Free Software Foundation; either          *
 *   version 2.1 of the License, or (at your option) any later version.    *
 *                                                                         *
 *   This library is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU     *
 *   Lesser General Public License for more details.                       *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this library; if not, write to the Free Software   *
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston,                 *
 *   MA  02111-1307  USA                                                   *
 *                                                                         *
 ***************************************************************************/

/*
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifdef __declspec
# if BUILDING_DLL
#  define DLLIMPORT __declspec (dllexport)
# else /* Not BUILDING_DLL */
#  define DLLIMPORT __declspec (dllimport)
# endif /* Not BUILDING_DLL */
#else
# define DLLIMPORT
#endif

#include <string>
#include <list>

#include <hbci.h>
#include <auth.h>

namespace HBCI {

Auth::Auth(Hbci *hbci)
    :_hbci(hbci){
}


Auth::~Auth(){
}


Error Auth::getSecret(Pointer<User> user,
                              const string &token,
                              string &secret,
                              bool confirm){
    string s;
    if (!_hbci->interactor().ref().msgInputPin(user,
                                               s,
                                               4,
                                               confirm))
        return Error("Auth::getSecret()",
                         ERROR_LEVEL_NORMAL,
                         HBCI_ERROR_CODE_PIN_ABORTED,
                         ERROR_ADVISE_DONTKNOW,
                         "could not get secret",
                         "user aborted pin dialog");
    if (s.length()<4) {
        return Error("Auth::getSecret()",
                         ERROR_LEVEL_NORMAL,
		     HBCI_ERROR_CODE_PIN_TOO_SHORT,
                         ERROR_ADVISE_DONTKNOW,
                         "Pin is too short.");
        fprintf(stderr,"Warning:\n"
                "Your program returns a pin that is shorter than\n"
                "the demanded size. This is a violation of the API\n"
                "so you should report to the author of your "
                "program.\n");
    }
    secret=s;
    return Error();
}

} // namespace HBCI
